import java.util.Objects;

public class DynBindList {
    private AbstrListNode head = EmptyListNode.NIL;

    public void addFirst(String value) {
        head = new NonEmptyListNode(value, head);
    }

    public String peekFirst() {
        return head.value();
    }

    public String pollFirst() {
        String result = head.value();
        head = head.next();
        return result;
    }

    public void addLast(String value) {
        head = head.addLast(value);
    }

    public String peekLast() {
        return head.peekLast().value();
    }

    public String pollLast() {
        String result = peekLast();
        head = head.removeLast();
        return result;
    }

    public boolean isEmpty() {
        return head.isEmpty();
    }

    public String toString() {
        return head.toString();
    }

    public void print() {
        System.out.println(toString());
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        DynBindList that = (DynBindList) o;
        return head.equals(that.head);
    }

    @Override
    public int hashCode() {
        return head.hashCode() + 876345219;
    }
}
