public class TestAssoc {
    public static void main(String[] args) {
        testBoth();
    }

    private static void testAssoc(Assoc assoc) {
        final String name = assoc.getClass().getName();
        System.out.println("Einfügen in " + name);
        for (int i = 1; i <= 5000; i += 2) {
            assoc.put("Key" + i, "Value" + i);
        }
        System.out.println("Auslesen aus " + name + " mit containsKey");
        for (int i = 1; i <= 5000; i += 3) {
            assoc.containsKey("Key" + i);
        }
        System.out.println("Auslesen aus " + name + " mit get");
        for (int i = 1; i <= 5000; i += 3) {
            assoc.get("Key" + i);
        }
        System.out.println("Auslesen aus " + name + " mit containsValue");
        for (int i = 1; i <= 5000; i += 3) {
            assoc.containsValue("Value" + i);
        }
        System.out.println("Ändern in " + name + " mit putConditional");
        for (int i = 1; i <= 5000; i += 3) {
            assoc.put("Key" + i, "Value" + i);
        }
        System.out.println(assoc);
        System.out.println(name + " fertig getestet");
    }

    private static void testBoth() {
        SimpleAssoc sa1 = new SimpleAssoc();
        SimpleAssoc sa2 = new SimpleAssoc();
        TreeAssoc ta1 = new TreeAssoc();
        TreeAssoc ta2 = new TreeAssoc();

        testAssoc(sa1);
        testAssoc(sa2);
        testAssoc(ta1);
        testAssoc(ta2);

        System.out.println();
        System.out.println(sa1 == sa2);
        System.out.println(sa1.equals(sa2));
        System.out.println(sa2.equals(sa1));
        System.out.println(sa1.hashCode());
        System.out.println(sa2.hashCode());

        System.out.println();
        System.out.println(ta1 == ta2);
        System.out.println(ta1.equals(ta2));
        System.out.println(ta2.equals(ta1));
        System.out.println(ta1.hashCode());
        System.out.println(ta2.hashCode());

        System.out.println();
        sa1.put("neu", "neu");
        ta1.put("neu", "neu");
        System.out.println(sa1.equals(sa2));
        System.out.println(sa1.hashCode());
        System.out.println(sa2.hashCode());
        System.out.println(ta1.equals(ta2));
        System.out.println(ta1.hashCode());
        System.out.println(ta2.hashCode());

        System.out.println();
        sa1.remove("neu");
        ta2.put("neu", "neu");
        System.out.println(sa1.equals(sa2));
        System.out.println(sa1.hashCode());
        System.out.println(sa2.hashCode());
        System.out.println(ta1.equals(ta2));
        System.out.println(ta1.hashCode());
        System.out.println(ta2.hashCode());
    }

}
