public class TestIterator {

    public static void main(String[] args) {
        Queue lq = new ListQueue();
        Deque deq = new DEQueue();
        fill(lq);
        fill(deq);

        print(lq);
        print(deq);
        System.out.println();

        printBoth(lq, deq);
        printBoth(lq, lq);
        printBoth(deq, deq);
    }


    private static void print(Iterable data) {
        // for (String s : data) {
        //    System.out.print(s);
        //}
        Iterator iter = data.iterator();
        while (iter.hasNext()) {
            System.out.print(iter.next());
        }
        System.out.println();
    }

    private static void printBoth(Iterable d1, Iterable d2) {
        Iterator i1 = d1.iterator();
        Iterator i2 = d2.iterator();
        while (i1.hasNext() && i2.hasNext()) {
            System.out.print(i1.next() + i2.next());
        }
        System.out.println();
    }

    private static void fill(Queue queue) {
        for (char c = 'a'; c <= 'z'; c++) {
            queue.add(c + "");
        }
    }

}
