public class TestOrderedTree {

    public static void main(String[] args) {
        Ordered ord = new OrderedTree();
        fill(ord);
        search(ord);
        print(ord);
        copyArray(ord);
        copyIter(ord);
    }

    private static void fill(Collection collection) {
        for (char i = 0; i < 10000; i++) {
            collection.add("" + (int)(Math.random() * 100000.0));
        }
    }

    private static void search(Collection collection) {
        int cnt = 0;
        for (int i = 0; i < 10000; i++) {
            String s = "" + (int) (Math.random() * 100000.0);
            cnt += collection.contains(s);
            collection.removeAll(s);
        }
        System.out.println(cnt + " Einträge gefunden (bei 10000 Suchschritten)");
    }

    private static void print(Collection collection) {
        //for (String s : collection) {
        //    System.out.print(s + " ");
        //}
        System.out.println(collection);
        System.out.println(collection.size() + " Zeichenketten ausgegeben");
    }

    private static void copyIter(Collection collection) {
        System.out.println("Beginne Kopieren über Iterator und Vergleichen");
        System.out.println(collection.equals(new OrderedTree(collection)));
    }

    private static void copyArray(Collection collection) {
        System.out.println("Beginne Kopieren über Array und Vergleichen");
        System.out.println(collection.equals(new OrderedTree(collection.toArray())));
    }

}
