public class KeySet implements Collection {
    private HashTab tab;

    public KeySet(HashTab t) {
        tab = t;
    }

    public void add(String element) {
        if (!tab.containsKey(element)) {
            tab.put(element, element);
        }
    }

    public int contains(String e) {
        return tab.containsKey(e) ? 1 : 0;
    }

    public int removeAll(String e) {
        if (tab.containsKey(e)) {
            tab.remove(e);
            return 1;
        }
        return 0;
    }

    public void clear() {
        tab.clear();
    }

    public int size() {
        return tab.size();
    }

    public String[] toArray() {
        String[] keys = new String[size()];
        tab.keyArray(keys);
        return keys;
    }

    public Iterator iterator() {
        return tab.keyIterator();
    }

    public String toString() {
        String s = "";
        for (String e : this) {
            s += s.equals("") ? e : ", " + e;
        }
        return "{" + s + "}";
    }

    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || o.getClass() != KeySet.class) {
            return false;
        }
        KeySet that = (KeySet) o;
        return this.tab.equals(that.tab);
    }

    public int hashCode() {
        return 54321 * tab.hashCode();
    }
}
