public class OTNode {
    private String elem;
    private OTNode left, right;
    private int balance = 0;

    public OTNode(String e) {
        elem = e;
    }

    private int compare(String e) {
        if (e == null) {
            return elem == e ? 0 : -1;
        }
        return elem == null ? 1 : e.compareTo(elem);
    }

    public OTNode add(String e) {
        if (compare(e) > 0) {
            if (right == null) {
                right = new OTNode(e);
                ++balance;
            } else {
                OTNode n = right.add(e);
                if (n != null) {
                    right = n;
                    return this;
                }
                if (++balance > 1) {
                    if (right.balance > 0) {
                        n = right;
                        balance = 0;
                    } else {
                        n = right.left;
                        balance = right.balance = 0;
                        if (n.balance > 0) {
                            balance = -1;
                        } else if (n.balance < 0) {
                            right.balance = 1;
                        }
                        right.left = n.right;
                        n.right = right;
                    }
                    n.balance = 0;
                    right = n.left;
                    n.left = this;
                    return n;
                }
            }
        } else {
            if (left == null) {
                left = new OTNode(e);
                --balance;
            } else {
                OTNode n = left.add(e);
                if (n != null) {
                    left = n;
                    return this;
                }
                if (--balance < -1) {
                    if (left.balance < 0) {
                        n = left;
                        balance = 0;
                    } else {
                        n = left.right;
                        balance = left.balance = 0;
                        if (n.balance < 0) {
                            balance = 1;
                        } else if (n.balance > 0) {
                            left.balance = -1;
                        }
                        left.right = n.left;
                        n.left = left;
                    }
                    n.balance = 0;
                    left = n.right;
                    n.right = this;
                    return n;
                }
            }
        }
        return balance != 0 ? null : this;
    }

    public int contains(String e) {
        int count = 0;
        OTNode n = this;
        do {
            int cmp = n.compare(e);
            if (cmp > 0) {
                n = n.right;
            } else {
                n = n.left;
                if (cmp == 0) {
                    count++;
                }
            }
        } while (n != null);
        return count;
    }

    public int fill(String[] array, int i) {
        if (left != null) {
            i = left.fill(array, i);
        }
        if (i < array.length) {
            array[i++] = elem;
            if (right != null) {
                i = right.fill(array, i);
            }
        }
        return i;
    }

    public String iter(OTIter iter, boolean next) {
        OTNode n = next ? right : this;
        while (n != null) {
            new OTIter(n, iter);
            n = n.left;
        }
        return elem;
    }

    public int depth() {
        if (balance > 0) {
            return right.depth() + 1;
        } else if (left != null) {
            return left.depth() + 1;
        } else {
            return 1;
        }
    }

    public String toString() {
        String s = "[";
        if (left != null) {
            s += left;
        }
        if (balance < 0) {
            s += "+";
        }
        s += elem;
        if (balance > 0) {
            s += "+";
        }
        if (right != null) {
            s += right;
        }
        return s + "]";
    }
}
