import java.io.*;

public class Numbered {
    private static final String errMsg = "Usage: java Numbered <in> <out>";

    public static void main(String[] args) {
        if (args.length != 2) {
            System.err.println(errMsg);
            return;
        }
        try {
            BufferedReader in = null;
            BufferedWriter out = null;
            try {
                Reader r = new FileReader(args[0]);
                Writer w = new FileWriter(args[1]);
                in = new BufferedReader(r);
                out = new BufferedWriter(w);
                String line;
                for (int i = 1; (line = in.readLine()) != null; i++) {
                    out.write(String.format("%6d: %s\n", i, line));
                }
            } finally {
                if (in != null) {
                    in.close();
                }
                if (out != null) {
                    out.close();
                }
            }
        } catch (IOException e) {
            System.err.println("I/O Error: " + e.getMessage());
        }
    }
}
